; 
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;USART Transmit Complete Interrupt
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
; Mit RETI in der Vektorsprungtabelle ist es auch getan
;
;
_UTXCaddr:
; in   s_sreg,SREG           ;Statusregister sichern 

; out  SREG,s_sreg           ;Statusregister wiederherstellen
; reti                       ;Ruecksprung aus der Interrupt Service Routine     
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Timer0 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_TIM0_OVF:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 
;
;Tasterentprellung. Das Bit key.actuated ( Taster betaetigt & entprellt )
;wird nach dem Auswerten in der Hauptprogrammschleife rueckgesetzt.
;
 bst  key_reg,key.unactuated;Taster betaetigt & entprellt im T-Flag speichern 
 sbis KEY_PIN,key.bit       ;Taster unbetaetigt?
 rjmp _actuated             ;Nein => Taster betaetigt
 brts _counterrestore       ;Zaehler auf 4 ruecksetzen
 rjmp _count                ;Bis 3 Zaehlen
_actuated:
 brts _count                ;Weiter von 5 bis 8 zaehlen
_counterrestore:
 cbr  key_reg,$03           ;Zaehlerbits 1&0 ruecksetzen
_count:
 sbrs key_reg,key.actuated  ;Taster betaetigt entprellt?
 inc  key_reg   
;
;ProgrammLaufAnzeige-LED ( PLA-LED ) blinken lassen 
;
 sbrs flag_reg,pla.flg      ;PLA-Flag in der Mainschleife quitiert?...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen

 inc  ovf0_zlr              ;Overflowzaehler inkrementieren...
 sbrs ovf0_zlr,#ovf0_zlr    ;...bis 4 gezaehlt?...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen
 clr  ovf0_zlr              ;Overflowzaehler ruecksetzen

 sbi  PLA_PIN, led.pla      ;Programmlaufanzeige LED toggeln
;
;Timer0 Overflow ISR verlassen
; 
_exit_OVF0addr:             ;Timer0 Overflow Interrupt verlassen
 cbr flag_reg,1<<pla.flg    ;Programmlaufanzeige-Flag quitieren
 
 out  SREG,s_sreg           ;Statusregister wiederherstellen
 
 reti                       ;Ruecksprung aus der Timer0 Overflow ISR
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Timer2 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
/*
_OVF2addr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 

 dec  ovf2_zlr          ;20MHz / 8 / 256 = alle 102,4s ein Overflow
 brne _exit_OVF2addr        ;Timer2 Overflow Interrupt verlassen
 sbr  flag_reg,1<<tc2.ovf   ;Flagge fuer _main: -> Pseudo Timer2 Overflow-Flag
;
;Timer2 Overflow ISR verlassen
; 
_exit_OVF2addr:             ;Timer2 Overflow Interrupt verlassen
 
 out  SREG,s_sreg           ;Statusregister wiederherstellen
 reti                       ;Ruecksprung aus der Timer2 Overflow ISR
*/
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Analog-Digital-Wandler ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
/*
_ADCCaddr:	                ; ADC Conversion Complete
 in   s_sreg,SREG           ;CPU-Statusregister sichern 

.equ  cp2 = $03FF+2 
 
 ;sub  mwn,mwl               ;1/256..
 ;sbc  mwl,mwh               ;..des Mittelwertinhalts..
 ;sbc  mwh,null              ;..rausnehmen und wegwerfen
 ;lds  ia,adcl              ;10-Bit des ADCs.. 
 ;lds  ib,adch               ;..einlesen..
 ;add  mwn,ia                ;..und 1/256 des neuen Messwertes..
 ;adc  mwl,ib                ;..zum Mittelwert..
 ;adc  mwh,null              ;..hinzuaddieren

 add  mwn,xl                ;
 adc  mwl,xh                ;
 adc  mwh,null              ;
 dec  z_adc_addition        ;Zaehler sorgt f. 256 ADC-Werte addieren
 breq _mittelwert           ;256 Additionen durchgefuehrt? -> JA springen
 rjmp _exit_ADCCaddr        ;Ruecksprung aus der ADC-ISR
_mittelwert: 
 ldi  zl, LOW(_adc_werte)   ;SRAM-Anfangsadresse der ADC-Werte 
 ldi  zh,HIGH(_adc_werte)   ;..holen und..
 st   z+,mwl                ;..Mittelwerte dort..
 st   z+,mwh                ;..speichern

 inc  xl
 brne _lowbyte
 inc  xh
_lowbyte:
 ldi  compare_temp,high(cp2)
 cpi  xl,low(cp2)
 cpc  xh,compare_temp
 brcs _weiter
 rjmp pc                    ;S T O P ###########################################
 ldi  xl,1
 clr  xh
_weiter:
;TESTZWECKE ####################################################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 ;mov  mwh,ib
 sts  UDR0,mwh              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 ;mov  mwl,ia
 sts  UDR0,mwl              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 sts  UDR0,mwn              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 sts  UDR0,z_adc_addition   ;TESTZWECKE ########################################
;TESTZWECKE ####################################################################

 clr  mwn
 clr  mwl
 clr  mwh
 sbr  flag_reg,1<<mwert.rdy ;Flag Mittelwertsbildung fertig
  
_exit_ADCCaddr:

;TESTZWECKE ####################################################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 ;mov  mwh,ib
 sts  UDR0,mwh              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 ;mov  mwl,ia
 sts  UDR0,mwl              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 sts  UDR0,mwn              ;TESTZWECKE ########################################
 rcall _warte_udre          ;TESTZWECKE ########################################
 sts  UDR0,z_adc_addition   ;TESTZWECKE ########################################
;TESTZWECKE ####################################################################
 
 lds  ia,ADCSRA             ;ADC-Einzelwandlung ( Single Coversion )..
 ori  ia,1<<ADSC            ;..erneut..
 sts  ADCSRA,ia             ;..starten
 
 out  SREG,s_sreg           ;Statusregister wiederherstellen
 reti                       ;Ruecksprung aus der ADC-ISR
*/
