;
.include "Header.inc"       ;Label und Werte Zuweisungen
.include "Hardware.inc"     ;Hardware Label  Zuweisungen
;
;Programmstart nach RESET  ( Interrupt Vektoren Tabelle )
;
.CSEG                       ;Was ab hier folgt kommt in den FLASH-Speicher
.ORG $0000                  ;Programm beginnt an der FLASH-Adresse 0x0000..

 rjmp  _reset               ;..mit der RESET-Vectortabelle

.include "IRQt13.inc"       ;Restliche Interrupt Vektortabelle

.ORG INT_VECTORS_SIZE       ;Programmadresse nach den ganzen IRQ-Vektoren
;
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;I Erstinitialisierungen
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;
;Stapelzeiger initialisieren (fuer Unterprogramme und / oder Interrupts)
;
_reset:
 ;ldi  a,High(RAMEND)        ;RAMEND, also das Ende vom SRAM, ist in der.. 
 ;out  SPH,a                 ;..Definitions-datei festgelegt  
 ldi  a,Low (RAMEND)        ;Hier reicht ein Byte, weil das...
 out  SPL,a                 ;...SRAM nur 64Byte gross ist
;
;Ports Erstkonfiguration
; 
 sbi  PLA_PORT,led.pla      ;PraogrammLaufAnzeige-LED aus ( Vorerst Pullup )
 sbi  PLA_DDR, led.pla      ;PORT-Bit als Ausgang f. PLA-LED
 ;
;Timer/Counter0 Overflow-Interuppt initialisieren
;
 ;ldi  a,1<<TOIE0            ;Timer/Counter0 Overflow Interrupt... 
 ;out  TIMSK0,a              ;...enablen (TOIE0)
;
;ADC ( Analog-Digital-Wandler initialisieren ( Single Conversion Mode )
;75kHz, Interruptbasierend
;
 ldi  a,1<<ADEN|1<<ADSC|1<<ADATE|1<<ADIE|1<<ADPS2  ;IRQ, ADC-Takt = Systemtakt / 16..        
 out  ADCSRA,a              ;..( 75kHz bei 1,2MHz ), ADC freigeben & starten
 ldi  a,1<<ADLAR            ;10-Bit Ergebnis linksbuendig..
 out  ADMUX,a               ;..in ADCH
;
;Fast PWM-Mode ( 7 ) initialisieren, NON-INVERT, ohne Vorteiler.
;Clear OC0B on Compare Match, set OC0B at TOP. OC0B ist der PWM-Pinn,
;da OCR0A ja den TOP-Wert enthlt.
;
 ldi  a,#max                ;Zhlumfang erstmal Maximum...
 out  Z_UMFANG,a            ;...einstellen...
 
 ldi  a,1<<WGM00|1<<WGM01|1<<COM0B1|1<<COM0A0 ;Fast PWM-Mode 7..
 out  TCCR0A,a              ;..Clear OC0A on Compare Match, set OC0A at TOP..
 ldi  a,1<<CS00|1<<WGM02    ;...ohne Vorteiler..
 out  TCCR0B,a              ;..Timer/Counter0 starten und..
 sbi  DDRB,PWM_1            ;..PWM-Portpinn als Ausgang  freigeben
 
 sbi  DDRB,PWM_1+1          ;TEST###############################################
 
 sei                        ;Alle programmierbaren Interrupts freigeben
;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;H Hauptprogrammschleife
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;
;Jeweils das Wandlungsende abwarten, den ADC-Wert einlesen, diesen in die 
;entsprechenden OCR0x-Register schreiben und den ADC-Kanal wechseln 
;
_main:
 rjmp _main                 ;Alles von vorne
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
.include "ISR.inc"          ;Interrupt Service Routinen

.EXIT                       ;Ende des Quelltextes
